<?php

/*
  Admin Setup
*/

global $wpdb;
$agents_table = $wpdb->prefix . "livelychatsupport_agents";
$hours_table = $wpdb->prefix . "livelychatsupport_hours";
$agents = $wpdb->get_results("SELECT * FROM $agents_table");
$hours = $wpdb->get_results("SELECT * FROM $hours_table");

$convo = (object) array(
  "token" => "notta", 
  "name" => "John Doe", 
  "email" => "johndoe@example.com"
);

$messages = array(
  (object) array(
    "convo_token" => "notta",
    "body" => "How can I help you today?",
    "from_agent" => true,
    "created_at" => date("Y-m-d H:i:s", current_time("timestamp"))
  ),
  (object) array(
    "convo_token" => "notta",
    "body" => "Just wondering about the sale price on these shoes...",
    "from_agent" => false,
    "created_at" => date("Y-m-d H:i:s", current_time("timestamp"))
  )
);

?>

<style type="text/css">
  #livelychatsupport-chatbox .cta_online_image { <?php echo $livelychatsupport["position"]; ?>: <?php echo $livelychatsupport["cta_online_image_offset_x"]; ?>px; bottom: <?php echo $livelychatsupport["cta_online_image_offset_y"]; ?>px !important; margin-bottom: 5px; }
  #livelychatsupport-chatbox .cta_offline_image { <?php echo $livelychatsupport["position"]; ?>: <?php echo $livelychatsupport["cta_offline_image_offset_x"]; ?>px; bottom: <?php echo $livelychatsupport["cta_offline_image_offset_y"]; ?>px !important; margin-bottom: 208px; }
  #livelychatsupport-chatbox.offline .cta_offline_image { display: block; }
  #livelychatsupport-chatbox.offline .cta_online_image { display: none !important; }
  #livelychatsupport .livelychatsupport-iframe { display: none; }
</style>

<form action="admin.php?page=livelychatsupport&tab=settings" method="post">
  
  <h2>Lively Chat Theme</h2>

  <div id="livelychatsupport-online" class="livelychatsupport-design-form" data-mode="online">
    <div class="field">
      <label for="colour">Colour</label><br>
      <input type="text" name="colour" id="colour" value="<?php echo $livelychatsupport["colour"]; ?>" />
    </div>
  
    <div class="field">
      <label for="cta_text">Call To Action Text</label><br>
      <input type="text" name="cta_online_text" id="cta_online_text" class="cta_text" value="<?php echo $livelychatsupport["cta_online_text"]; ?>" />
    </div>
  
    <div class="field">
      <label for="cta_online_image">Call To Action Image</label><br>
    
      <a href="#" class="livelychatsupport-detail livelychatsupport-show-prebuilt_ctas">Use pre-built</a>,
      <a href="#" class="livelychatsupport-detail choose_cta_online_image">Choose file</a>, or
      <a href="#" class="livelychatsupport-detail no_cta_online_image">No image</a><br>
      <ul class="livelychatsupport-prebuilt_ctas">
        <?php
          $ctas = opendir(LIVELYCHATSUPPORT_ROOT. "/chatbox/assets/ctas/online");
          
          if ($ctas) {
          while (false !== ($cta = readdir($ctas))) { 
            if ($cta != "." && $cta != "..") { ?>
            
          <li><img src="<?php echo plugins_url( "lively-chat-support/chatbox/assets/ctas/online/$cta" ); ?>"></li>
        
        <?php } } } ?>
      </ul>
      
      <input type="hidden" name="cta_online_image_offset_y" id="cta_online_image_offset_y" value="<?php echo $livelychatsupport["cta_online_image_offset_y"]; ?>" />
      <input type="text" name="cta_online_image" id="cta_online_image" class="cta_image" value="<?php echo $livelychatsupport["cta_online_image"]; ?>" /><br>
      <span class="livelychatsupport-detail">Hint: You can drag the image vertically.</span>
    </div>
  
    <div class="field">
      <label for="position">
        Position on Screen<br>
        <span class="livelychatsupport-detail">Hint: Aligns image if present.</span>
      </label><br>
      <select id="position" name="position">
        <option value="right" <?php if ($livelychatsupport["position"] == "right") { echo "selected='selected'"; } ?>>Bottom Right</option>
        <option value="left" <?php if ($livelychatsupport["position"] == "left") { echo "selected='selected'"; } ?>>Bottom Left</option>
      </select>
    </div>
    
    <div class="field">
      <label for="subscriber_email">Email responses to which address?</label><br>
      <input type="text" name="subscriber_email" id="subscriber_email" value="<?php echo $livelychatsupport["subscriber_email"]; ?>" />
    </div>
    
    <div class="field">
      <input type="checkbox" id="show_powered_by"<?php if ($livelychatsupport["show_powered_by"] == "true") { echo " checked=\"checked\""; } ?> />
      <input type="hidden" name="show_powered_by" id="hidden_show_powered_by" value="<?php echo $livelychatsupport["show_powered_by"]; ?>" />
      <label for="show_powered_by">Show "Powered By Lively Chat"</label>
    </div>
  
    <div class="field">
      <input type="submit" value="Save My Settings" class="button-primary" />
    </div>
  </div>
  
  <div class="livelychatsupport-preview" data-mode="online">
    <?php
      
      $livelychatsupport_open = true;
      unset($livelychatsupport_offline); 
      $livelychatsupport_chatting = true;
      
      include(LIVELYCHATSUPPORT_ROOT. "/chatbox/includes/structure.php");
    ?>
  </div>

  <div class="clear"></div>

  <hr />

  <h2>Offline Mode (aka. the perfect lead-collection form)</h2>

  <div id="livelychatsupport-offline" class="livelychatsupport-design-form" data-mode="offline">
    <div class="field">
      <label for="cta_text">Call To Action Text</label><br>
      <input type="text" name="cta_offline_text" id="cta_offline_text" class="cta_text" value="<?php echo $livelychatsupport["cta_offline_text"]; ?>" />
    </div>

    <div class="field">
      <label for="cta_offline_image">Call To Action Image</label><br>
  
      <a href="#" class="livelychatsupport-detail livelychatsupport-show-prebuilt_ctas">Use pre-built</a>,
      <a href="#" class="livelychatsupport-detail choose_cta_offline_image">Choose file</a>, or
      <a href="#" class="livelychatsupport-detail no_cta_offline_image">No image</a><br>
      <ul class="livelychatsupport-prebuilt_ctas">
        <?php
          $ctas = opendir(LIVELYCHATSUPPORT_ROOT. "/chatbox/assets/ctas/offline");
          if ($ctas) {
          while (false !== ($cta = readdir($ctas))) { 
            if ($cta != "." && $cta != "..") { ?>
          
          <li><img src="<?php echo plugins_url( "lively-chat-support/chatbox/assets/ctas/offline/$cta" ); ?>"></li>
      
        <?php } } } ?>
      </ul>
      
      <input type="hidden" name="cta_offline_image_offset_y" id="cta_offline_image_offset_y" value="<?php echo $livelychatsupport["cta_offline_image_offset_y"]; ?>" />
      <input type="text" name="cta_offline_image" id="cta_offline_image" class="cta_image" value="<?php echo $livelychatsupport["cta_offline_image"]; ?>" /><br>
      <span class="livelychatsupport-detail">Hint: You can drag the image vertically.</span>
    </div>
    
    <div class="field">
      <label for="offline_thanks">Thank you text after submission</label><br>
      <textarea id="offline_thanks" name="offline_thanks"><?php echo stripslashes($livelychatsupport["offline_thanks"]); ?></textarea><br>
      <span class="livelychatsupport-detail">Hint: Basic HTML is acceptable.</span><br>
    </div>
    
    <div class="field">
      <input type="submit" value="Save My Settings" class="button-primary" />
    </div>
  </div>
  
  <div class="livelychatsupport-preview" data-mode="offline">
    <?php
      
      $livelychatsupport_open = true;
      $livelychatsupport_offline = true; 
      unset($livelychatsupport_chatting);
      
      include(LIVELYCHATSUPPORT_ROOT . "/chatbox/includes/structure.php");
    ?>
  </div>

  <div class="clear"></div>

  <hr />
  
  

  <h2>LivelyChatSupport Office Hours</h2>
  
  <div class="field">
    <select name="online" id="online">
      <option <?php if ($livelychatsupport["online"] == "hours") { echo "selected='selected'"; } ?>value="hours">Online According to Office Hours</option>
      <option <?php if ($livelychatsupport["online"] == "online") { echo "selected='selected'"; } ?>value="online">Always Online</option>
      <option <?php if ($livelychatsupport["online"] == "offline") { echo "selected='selected'"; } ?>value="offline">Always Offline</option>
      <option <?php if ($livelychatsupport["online"] == "hidden") { echo "selected='selected'"; } ?>value="hidden">Don't Show LivelyChatSupport At All</option>
    </select>
  </div>
  
  <div class="field hours_field">
    <p>Is it <b><?php echo date("g:i A \\o\\n l", current_time("timestamp")); ?></b>? If not, change your timezone on the <a href="options-general.php">General Settings</a> page.
      
    <table class="widefat">
      <thead>
        <tr>
          <th>Day</th>
          <th class="center">Open At <span class="faint">(eg. 6am, 6 AM, 6:00 AM)</span></th>
          <th class="center">Close At <span class="faint">(eg. 6am, 6 AM, 6:00 AM)</span></th>
          <th class="center">Who Should Respond?</th>
          <th class="center">Contact Method</th>
          <th></th>
        </tr>
      </thead>
      <tbody id="hours">
        
        <?php $n = 0; foreach($hours as $hour) { ?>
          <tr class="hour">
            <td>
              <input type="hidden" name="hours[<?php echo $n; ?>][id]" class="id" value="<?php echo $hour->id; ?>" />
              <select name="hours[<?php echo $n; ?>][day]">
                <option <?php if ($hour->day == "Sunday") { echo "selected=\"selected\""; } ?>>Sunday</option>
                <option <?php if ($hour->day == "Monday") { echo "selected=\"selected\""; } ?>>Monday</option>
                <option <?php if ($hour->day == "Tuesday") { echo "selected=\"selected\""; } ?>>Tuesday</option>
                <option <?php if ($hour->day == "Wednesday") { echo "selected=\"selected\""; } ?>>Wednesday</option>
                <option <?php if ($hour->day == "Thursday") { echo "selected=\"selected\""; } ?>>Thursday</option>
                <option <?php if ($hour->day == "Friday") { echo "selected=\"selected\""; } ?>>Friday</option>
                <option <?php if ($hour->day == "Saturday") { echo "selected=\"selected\""; } ?>>Saturday</option>
              </select>
            </td>
            <td class="center">
              <input type="text" name="hours[<?php echo $n; ?>][open_at]" value="<?php echo LivelyChatSupport_military_to_pretty((string)$hour->open_at); ?>" class="center" />
            </td>
            <td class="center">
              <input type="text" name="hours[<?php echo $n; ?>][close_at]" value="<?php echo LivelyChatSupport_military_to_pretty((string)$hour->close_at); ?>" class="center" />
            </td>
            <td class="center">
              <select name="hours[<?php echo $n; ?>][responder_id]">
                <option value="0" <?php if ($hour->responder_id == 0) { echo "selected=\"selected\""; } ?>>Anyone</option>
                <?php foreach ($agents as $agent) { ?>
                  <option value="<?php echo $agent->id; ?>" <?php if ($hour->responder_id == $agent->id) { echo "selected=\"selected\""; } ?>><?php echo $agent->name; ?></option>
                <?php } ?>
              </select>
            </td>
            <td class="center">
              <select name="hours[<?php echo $n; ?>][via]">
                <?php if ($livelychatsupport["twilio_auth"] != "") { ?>
                  <option value="sms" <?php if ($hour->via == "sms") { echo "selected=\"selected\""; } ?>>SMS</option>
                <?php } ?>
                <option value="web" <?php if ($hour->via == "web") { echo "selected=\"selected\""; } ?>>Wordpress</option>
              </select>
            </td>
            <td>
              <input type="hidden" name="hours[<?php echo $n; ?>][delete]" value="0" class="delete" />
              <a href="#" class="delete_row button-secondary" data-row="hour">Delete</a>
            </td>
          </tr>
        <?php $n += 1; } ?>
        
        <tr class="hour hour_template template">
          <td>
            <select name="hours[][day]">
              <option>Sunday</option>
              <option>Monday</option>
              <option>Tuesday</option>
              <option>Wednesday</option>
              <option>Thursday</option>
              <option>Friday</option>
              <option>Saturday</option>
            </select>
            <input type="hidden" name="hours[][id]" class="id" />
          </td>
          <td class="center">
            <input type="text" name="hours[][open_at]" class="center" />
          </td>
          <td class="center">
            <input type="text" name="hours[][close_at]" class="center" />
          </td>
          <td class="center">
            <select name="hours[][responder_id]">
              <option value="0">Anyone</option>
              <?php foreach ($agents as $agent) { ?>
                <option value="<?php echo $agent->id; ?>"><?php echo $agent->name; ?></option>
              <?php } ?>
            </select>
          </td>
          <td class="center">
            <select name="hours[][via]">
              <?php if ($livelychatsupport["twilio_auth"] != "") { ?>
                <option value="sms">SMS</option>
              <?php } ?>
              <option value="web">Wordpress</option>
            </select>
          </td>
          <td>
            <input type="hidden" name="hours[][delete]" value="0" class="delete" />
            <a href="#" class="delete_row button-secondary" data-row="hour">Delete</a>
          </td>
        </tr>
        
      </tbody>
    </table>
    
    <br>
    <a href="#" class="add_row button-secondary" data-row="hour">Add Another Time Slot</a>
  </div>
  
  <div class="field">
    <input type="submit" value="Save My Settings" class="button-primary" />
  </div>
  
  <div class="clear"></div>

  <hr />

  <h2 id="delete_convos_anchor">History</h2>
  <b>Danger Zone: This action is irreversible.</b><br>
  
  <div class="field">
    <a href="#" class="delete_history button-secondary">Delete All Conversation and Visitor History</a>
  </div>

</form>

<form action="admin.php?page=livelychatsupport&tab=settings" method="post" id="delete_history">
  <input type="hidden" name="delete_history" value="1" />
</form>