<?php

global $wpdb;
$convos_table = $wpdb->prefix . "livelychatsupport_convos";
$convos = LivelyChatSupport_find_visitors();
$convo = $wpdb->get_row("SELECT * FROM $convos_table WHERE token = '$_GET[convo_token]'");

?>

<ul id="online_convos" class="livelychatsupport-sidebar" data-add_convo="<?php echo admin_url('admin-ajax.php'); ?>" data-convos="<?php echo htmlspecialchars(json_encode(array("convos" => $convos))); ?>">
  <li>
    <label>
      Start<br>
      <input type="text" id="start" value="<?php echo $livelychatsupport["start"] ?>" />
    </label>
    <a href="#" class="set_as_today" data-value="<?php echo date("F j, Y", current_time("timestamp")); ?>">Today</a>
    <a href="#" class="set_as_today" data-value="<?php echo date("F j, Y", current_time("timestamp") - 86400); ?>">Yesterday</a>
    <a href="#" class="set_as_today" data-value="<?php echo date("F j, Y", current_time("timestamp") - 604800); ?>">1 Week Ago</a>
    <div class="clear"></div>
  </li>
  <li>
    <label>
      Finish<br>
      <input type="text" id="finish" value="<?php echo $livelychatsupport["finish"] ?>" />
    </label>
    <a href="#" class="set_as_today" data-value="<?php echo date("F j, Y", current_time("timestamp")); ?>">Today</a>
    <a href="#" class="set_as_today" data-value="<?php echo date("F j, Y", current_time("timestamp") - 86400); ?>">Yesterday</a>
    <a href="#" class="set_as_today" data-value="<?php echo date("F j, Y", current_time("timestamp") - 604800); ?>">1 Week Ago</a>
    <div class="clear"></div>
  </li>
  <li class="divider"></li>
</ul>

<div class="livelychatsupport-yield-with-sidebar">
  
<?php if ($convo == null) { ?>
  
  <p>
    Choose a visitor on the left.
  </p>
  
<?php
  
  } else {
    
    $wpdb->update( 
      $convos_table, 
      array("pending" => false),
      array("token" => $convo->token)
    );
  
  ?>
  
  <a href="admin.php?page=livelychatsupport&tab=visitors&convo_token=<?php echo $convo->token; ?>&delete_convo=true" class="delete_convo button-secondary">Delete This Conversation</a>
  <p class="right_help">Delete all convos on the <a href="admin.php?page=livelychatsupport&tab=settings#delete_convos_anchor">Settings</a> page.</p>
  
  <?php if ($convo->name == "") { ?>
    <h1><?php echo $convo->city; ?>, <?php echo $convo->province; ?></h1>
    <div class="stats">
      <p>
        IP: <strong><?php echo $convo->ip; ?></strong><br>
        Last seen: <strong><?php echo date("D, M j, Y \a\\t g:ia", strtotime($convo->last_seen) + get_option("gmt_offset") * 60 * 60); ?></strong>
      </p>
  <?php } else { ?>
    <h1><?php echo $convo->name; ?></h1>
    <div class="stats">
      <p>
        Location: <strong><?php echo $convo->city; ?>, <?php echo $convo->province; ?></strong><br>
        Email: <strong><?php echo $convo->email; ?></strong><br>
        IP: <strong><?php echo $convo->ip; ?></strong><br>
        Last seen: <strong><?php echo date("D, M j, Y \a\\t g:ia", strtotime($convo->last_seen) + get_option("gmt_offset") * 60 * 60); ?></strong>
      </p>
  <?php }?>
  
      <ul id="all_pages">
        <?php foreach (array_reverse(json_decode($convo->referrers)) as $url) { ?>
          <li class="<?php if (!isset($first_page)) { echo "first_page"; } ?>">
            <span class="on_first">Now visiting: </span>
            <a href="<?php echo $url; ?>" target="_blank"><?php echo $url; ?></a>
            <span class="on_first">(<a href="#" class="show_all_pages">see all</a>)</span>
          </li>
          <?php if (!isset($first_page)) { $first_page = true; } ?>
        <?php } ?>
      </ul>
  
    </div>
    
  <div id="admin_chat" class="chat">
    
    <?php $messages = LivelyChatSupport_messages($convo->token, "desc") ?>
    
    <?php if ($wpdb->num_rows > 0) { ?>
      <form id="livelychatsupport-chatbox-new-message" action="<?php echo admin_url('admin-ajax.php'); ?>" method="post">
        <input type="hidden" id="livelychatsupport-chatbox-from_agent" name="from_agent" value="true">
        <input type="hidden" id="livelychatsupport-chatbox-token" name="livelychatsupport-chatbox-token" value="<?php echo $convo->token; ?>" />
        <textarea id="livelychatsupport-chatbox-body" name="livelychatsupport-chatbox-body" placeholder="Type here and press <Enter>" rows="1"></textarea>
        <img src="<?php echo plugins_url("lively-chat-support/chatbox/assets/loading.gif"); ?>" class="loading">
      </form>
    <?php } else { ?>
      <p>
        You can't talk to this person because they haven't registered yet.
      </p>
      <p>
        We'll be unlocking this feature in a future version.
      </p>
    <?php } ?>
  
    <ul id="messages" class="convo_<?php echo $convo->token; ?>_messages messages">
      <li class="message message_template">
        <p class="body"></p>
        <p class="date"></p>
        <div class="clear"></div>
      </li>
    
      <?php foreach ($messages as $message) { ?>
        <li class="message <?php if ($message->from_agent == 1) { echo "from_agent"; } ?>">
          <p class="body"><?php echo stripslashes($message->body); ?></p>
          <p class="date"><?php echo strftime("%l:%M", strtotime($message->created_at) + get_option("gmt_offset") * 60 * 60); ?></p>
          <div class="clear"></div>
        </li>
      <?php } ?>
    </ul>
    
  </div>
    
<?php } ?>

</div>